
// CardReaderDlg.cpp : implementation file
//----------------------------------------
#include "stdafx.h"
#include "CardReader.h"
#include "CardReaderDlg.h"
#include "MDBEngine.h"
#include "Info.h"
#include "Device.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CAboutDlg dialog used for App About
//------------------------------------

class CAboutDlg : public CDialog
//==============================
{
public:
	CAboutDlg();
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX); // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
//==============================================
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
//================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CCardReaderDlg dialog
//----------------------

CCardReaderDlg::CCardReaderDlg(CWnd* pParent) : CDialog(CCardReaderDlg::IDD, pParent)
//===================================================================================
{
	m_bRevalue=false;
	//{{AFX_DATA_INIT(CCardReaderDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon=AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCardReaderDlg::DoDataExchange(CDataExchange* pDX)
//=====================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCardReaderDlg)
	DDX_Control(pDX, IDC_DISPLAY_TIME, m_DisplayTime);
	DDX_Control(pDX, IDC_DISPLAY, m_Display);
	DDX_Control(pDX, IDC_PRICE, m_Price);
	DDX_Control(pDX, IDC_BALANCE, m_Balance);
	DDX_Control(pDX, IDC_ENABLED, m_Enabled);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCardReaderDlg, CDialog)
	//{{AFX_MSG_MAP(CCardReaderDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BEGIN_SESSION, OnBeginSession)
	ON_BN_CLICKED(IDC_END_SESSION, OnEndSession)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_APPROVE, OnApprove)
	ON_BN_CLICKED(IDC_DENY, OnDeny)
	ON_BN_CLICKED(IDC_INFO, OnInfo)
	ON_BN_CLICKED(IDC_DISPLAY_REQUEST, OnDisplayRequest)
	ON_COMMAND(IDM_ABOUTBOX, OnAboutbox)
	ON_WM_SYSCOMMAND()
	ON_COMMAND(IDM_DEVICE, OnDevice)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_MASTER_STATUS,CCardReaderDlg::OnReaderStatus)
END_MESSAGE_MAP()

// CCardReaderDlg message handlers
//--------------------------------

void CCardReaderDlg::OnAboutbox() 
//===============================
{
	CAboutDlg AboutDlg;
	AboutDlg.DoModal();
}

BOOL CCardReaderDlg::OnInitDialog()
//=================================
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.
	// The framework does this automatically
	// when the application's main window is not a dialog
	//---------------------------------------------------
	SetIcon(m_hIcon,TRUE); // Set big icon
	SetIcon(m_hIcon,FALSE); // Set small icon
	
	// Initialize MDB engine
	//----------------------
	CCardReaderApp* pApp=(CCardReaderApp*)AfxGetApp();
	CString sSection;
	sSection.Format(_T("Current%02u"),pApp->m_dwInstance);
	MASTER_SETUP Setup;
	memset(&Setup,0,sizeof(MASTER_SETUP));
	Setup.lParam=(LPARAM)this;
	Setup.hParent=m_hWnd;
//	Setup.dwDevice=AfxGetApp()->GetProfileInt(sSection,_T("Device"),0)+256;
	Setup.dwDevice=0;
	Setup.dwTimeout=3;
	Setup.dwRevalueLimit=10000;
	Setup.dwFeatureLevel=1;
	Setup.dwCountryCode=41;
	Setup.dwScalingFactor=1;
	Setup.dwDecimalPlaces=2;
	strcpy(Setup.sManufacturer,_T("BDS"));
	strcpy(Setup.sSerialNumber,_T("USB/MDB"));
	strcpy(Setup.sModelNumber,_T("BonusData AG"));
	Setup.wVersion=0x0100;
	if (!MasterCreate(&Setup))
	{
		TRACE(_T("Failed to create reader\r\n"));
	}
	m_DisplayTime.SetWindowText(_T("30"));

	// return TRUE  unless you set the focus to a control
	//---------------------------------------------------
	return TRUE;
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon. For MFC applications using the document/view model,
// this is automatically done for you by the framework.
//--------------------------------------------------------------------------

void CCardReaderDlg::OnPaint() 
//============================
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND,(WPARAM)dc.GetSafeHdc(),0);

		// Center icon in client rectangle
		//--------------------------------
		int cxIcon=GetSystemMetrics(SM_CXICON);
		int cyIcon=GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x=(rect.Width()-cxIcon+1)/2;
		int y=(rect.Height()-cyIcon+1)/2;

		// Draw the icon
		//--------------
		dc.DrawIcon(x,y,m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display
// while the user drags the minimized window.
//------------------------------------------------------

HCURSOR CCardReaderDlg::OnQueryDragIcon()
//=======================================
{
	return (HCURSOR) m_hIcon;
}

void CCardReaderDlg::OnDestroy() 
//==============================
{
	if (!MasterDestroy())
	{
		TRACE(_T("Failed to destroy reader\r\n"));
	}
	CDialog::OnDestroy();
}

void CCardReaderDlg::OnReaderStatus(WPARAM wParam, LPARAM lParam)
//===============================================================
{
	switch (wParam)
	{
		case MS_READER_ENABLE:
		{
			TRACE(_T("Request: ENABLE\r\n"));
			m_Enabled.SetCheck(1);
			break;
		}
		case MS_READER_DISABLE:
		{
			TRACE(_T("Request: DISABLE\r\n"));
			m_Enabled.SetCheck(0);
			break;
		}
		case MS_VEND_REQUEST:
		{
			TRACE(_T("Request: VEND REQUEST\r\n"));
			MASTER_INFO Info;
			MasterInfo(&Info);
			CString sTemp;
			sTemp.Format(_T("%u"),Info.dwItemPrice);
			m_Price.SetWindowText(sTemp);
			m_bRevalue=false;
			break;
		}
		case MS_VEND_SUCCESS:
		{
			TRACE(_T("Request: VEND SUCCESS\r\n"));
			CString sTemp;
			DWORD dwBalance;
			m_Balance.GetWindowText(sTemp);
			dwBalance=atoi(sTemp);
			m_Price.GetWindowText(sTemp);
			dwBalance-=atoi(sTemp);
			sTemp.Format(_T("%u"),dwBalance);
			m_Balance.SetWindowText(sTemp);
			m_Price.SetWindowText(_T("0"));
			break;
		}
		case MS_VEND_FAILURE:
		{
			TRACE(_T("Request: VEND FAILURE\r\n"));
			break;
		}
		case MS_REVALUE_REQUEST:
		{
			TRACE(_T("Request: REVALUE REQUEST\r\n"));
			MASTER_INFO Info;
			MasterInfo(&Info);
			CString sTemp;
			sTemp.Format(_T("%u"),Info.dwRevalueAmount);
			m_Price.SetWindowText(sTemp);
			m_bRevalue=true;
			break;
		}
		default:
		{
			TRACE(_T("Request: Unknown\r\n"));
		}
	}
}

void CCardReaderDlg::OnBeginSession() 
//===================================
{
	READER_SESSION Session;
	memset(&Session,0,sizeof(READER_SESSION));
	UpdateData(true);
	CString sTemp;
	m_Balance.GetWindowText(sTemp);
	Session.dwFunds=atoi(sTemp);
	MasterBeginSession(&Session);
}

void CCardReaderDlg::OnEndSession() 
//=================================
{
	MasterEndSession();
}

void CCardReaderDlg::OnReset() 
//============================
{
	MasterReset();	
}

void CCardReaderDlg::OnApprove() 
//==============================
{
	if (m_bRevalue)
	{
		MasterRevalue(true);
	}
	else
	{
		READER_APPROVED Approved;
		Approved.dwAmount=100;
		MasterApproved(&Approved);
	}
}

void CCardReaderDlg::OnDeny() 
//===========================
{
	if (m_bRevalue)
	{
		MasterRevalue(false);
	}
	else
	{
		MasterDenied();
	}
}

void CCardReaderDlg::OnInfo()
//===========================
{
	CInfo Info;
	Info.DoModal();
}

void CCardReaderDlg::OnDisplayRequest()
//=====================================
{
	READER_DISPLAY Display;
	CString sTemp;
	m_DisplayTime.GetWindowText(sTemp);
	Display.dwDisplayTime=atoi(sTemp);
	m_Display.GetWindowText(sTemp);
	while (sTemp.GetLength()<32)
		sTemp+=_T(" ");
	strcpy(Display.pDisplayData,sTemp);
	MasterDisplay(&Display);
}

void CCardReaderDlg::OnDevice() 
//=============================
{
	CDevice Device;
	Device.DoModal();
}
